/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: type.gi,v 1.2 2002/08/16 12:17:30 malekith Exp $
 *
 * Type - Type checker.
 */

open Ast;

void tycheck_decl(decl d);
void check_module_completness();

// Utilities for other modules.
ty type_of_s(expr e);
ty type_instance(ty t);
ty base_type(ty t);
bool is_void_func_type(ty t);
ty_symbol union_of(var_symbol label);
string string_of_type(ty t);
ty type_instance_one(ty t);
bool is_type_instance(ty t);
bool is_global_function(var_symbol s);

// don't look at it.
type ty_ctx
void tycheck_stmt(ty_ctx ctx, stmt s);
void tycheck_expr(ty_ctx c, expr e);
